/********************************************************
*  J[OtBbNLCD(240320hbgjpCu
*   \Őݒ
*	lcd_Init();		// 
*	lcd_Clear();		// Sʏ
*	lcd_Pixel();		// 1hbg\
*	lcd_Char();		// ANK\
*	lcd_Str();		// ANK\
*	lcd_Line();		// `
*	lcd_Circle();		// ~`
*********************************************************/
#include "p33FJ64GP802.h"
#include "colorlcd_libdsPICVH.h"
#include "ASCII12dot.h"		//ASCII 12x12dot

/************************************
* WX^ݒƃf[^o͊֐ 
*************************************/
void lcd_out(unsigned int index, unsigned int data){
	// IndexʃoCgo
	LCD_CS = 0;				// CS Low
	LCD_RS = 0;				// Command 
	LATB = (index & 0xFF00) | (LATB & 0x00FF);
	LCD_WR = 0;				// WR out
	Nop();
	LCD_WR = 1;
	// IndexʃoCgo
	LATB = ((index<<8)&0xFF00) | (LATB & 0x00FF);
	LCD_WR = 0;				// WR out
	Nop();
	LCD_WR = 1;
	// DataʃoCgo
	LCD_RS = 1;				// Data 
	LATB = (data & 0xFF00) | (LATB & 0x00FF);
	LCD_WR = 0;				// WR out
	Nop();
	LCD_WR = 1;
	// IndexʃoCgo
	LATB = ((data<<8)&0xFF00) | (LATB & 0x00FF);
	LCD_WR = 0;				// WR out
	Nop();
	LCD_WR = 1;	
	LCD_CS = 1;				// CS High

}

/****************************
* LCD֐  
*****************************/
void lcd_Init(void){
	delay_ms(20);
	LCD_RD = 1;
	LCD_CS = 1;				// CS High
	LCD_WR = 1;				// WR High
	LCD_RESET = 0;			// Reset LCD
	delay_ms(0x1);			// 1msec wait
	LCD_RESET = 1;			// Clear RESET
	delay_ms(25);				// 25msec wait

	lcd_out(0x00E3, 0x3008); 	// Set internal timing
	lcd_out(0x00E7, 0x0012); 	// Set internal timing
	lcd_out(0x00EF, 0x1231); 	// Set internal timing
	lcd_out(0x0001, 0x0000); 	// set SS and SM bit
	lcd_out(0x0002, 0x0700);	// set line inversion
	lcd_out(0x0003, 0x1018);	// set GRAM write direction and BGR=1, 16bit color
	lcd_out(0x0004, 0x0000);	// Resize register
	lcd_out(0x0008, 0x0207);	// set the back porch and front porch
	lcd_out(0x0009, 0x0000);	// set non-display area refresh cycle ISC[3:0]
	lcd_out(0x000A, 0x0000);	// FMARK function
	lcd_out(0x000C, 0x0000); 	// RGB interface setting
	lcd_out(0x000D, 0x0000);	// Frame marker Position
	lcd_out(0x000F, 0x0000);	// RGB interface polarity
	/********* dIV[PX  **************/
	lcd_out(0x0010, 0x0000); 	// SAP, BT[3:0], AP[2:0], DSTB, SLP, STB
	lcd_out(0x0011, 0x0007);	// DC1[2:0], DC0[2:0], VC[2:0]
	lcd_out(0x0012, 0x0000);	// VREG1OUT voltage
	lcd_out(0x0013, 0x0000); 	// VDV[4:0] for VCOM amplitude
	delay_ms(200); 			// RfTd҂
	lcd_out(0x0010, 0x1490); 	// SAP, BT[3:0], AP[2:0], DSTB, SLP, STB
	lcd_out(0x0011, 0x0227); 	// R11h=0x0221 at VCI=3.3V ,DC1[2:0], DC0[2:0], VC[2:0]
	delay_ms(50); 			// x 50ms
	lcd_out(0x0012, 0x001c); 	// External reference voltage= Vci;
	delay_ms(50); 			// x 50ms
	lcd_out(0x0013, 0x0A00); 	// R13=0F00 when R12=009E;VDV[4:0] for VCOM amplitude
	lcd_out(0x0029, 0x000F); 	// R29=0019 when R12=009E;VCM[5:0] for VCOMH//0012//
	lcd_out(0x002B, 0x000D); 	// Frame Rate = 91Hz
	delay_ms(50); 			// x 50ms
	lcd_out(0x0020, 0x0000); 	// GRAM horizontal Address
	lcd_out(0x0021, 0x0000); 	// GRAM Vertical Address
	/**********  K}␳  **********/
	lcd_out(0x0030, 0x0000);
	lcd_out(0x0031, 0x0203);
	lcd_out(0x0032, 0x0001);
	lcd_out(0x0035, 0x0205);
	lcd_out(0x0036, 0x030C);
	lcd_out(0x0037, 0x0607);
	lcd_out(0x0038, 0x0405);
	lcd_out(0x0039, 0x0707);
	lcd_out(0x003C, 0x0502);
	lcd_out(0x003D, 0x1008);
	/*********** GRAM̈ݒ *********/
	lcd_out(0x0050, 0x0000); 	// Horizontal GRAM Start Address
	lcd_out(0x0051, 0x00EF); 	// Horizontal GRAM End Address
	lcd_out(0x0052, 0x0000); 	// Vertical GRAM Start Address
	lcd_out(0x0053, 0x013F); 	// Vertical GRAM Start Address
	lcd_out(0x0060, 0xA700); 	// Gate Scan Line \p
	lcd_out(0x0061, 0x0001); 	// NDL,VLE, REV
	lcd_out(0x006A, 0x0000); 	// set scrolling line
	/************* \ ************/
	lcd_out(0x0080, 0x0000);	// \1ʒu
	lcd_out(0x0081, 0x0000);	// \1RAMJnAhX
	lcd_out(0x0082, 0x0000);	// \1RAMIAhX
	lcd_out(0x0083, 0x0000);	// \2ʒu	
	lcd_out(0x0084, 0x0000);	// \2RANJnAhX
	lcd_out(0x0085, 0x0000);	// \2RAMIAhX
	/************** pl ************/
	lcd_out(0x0090, 0x0010);	// 1CNbN
	lcd_out(0x0092, 0x0600);	// Q[gI[o[bvNbN
	lcd_out(0x0093, 0x0003);	// o̓^C~O
	lcd_out(0x0095, 0x0110);	// RGB1CNbN
	lcd_out(0x0097, 0x0000);	// o̓^C~O
	lcd_out(0x0098, 0x0000);	// o̓^C~O
	/***** \ *****/ 
	lcd_out(0x0007, 0x0133); 	// 262K color and display ON
}

/***************************
* ʏ֐
* pFw肠
****************************/
void lcd_Clear(unsigned short Color){
	int i, j;
	
	lcd_out(0x0020, 0);				// _ɃZbg
	lcd_out(0x0021, 0);
	for(	j=0; j<ENDROW; j++){			// YS
		for(i=0; i<ENDCOL; i++){		// XS
			lcd_out(0x0022, Color);	// FŖ߂
		}
	}
}
/***********************************
*  PsNZ\֐
*  W(0,0)-(161,131)  
***********************************/
void lcd_Pixel(short Xpos, short Ypos, unsigned short Color){

	if((Xpos<ENDCOL) && (Ypos<ENDROW)){
		lcd_out(0x0020, Ypos);			// Ww
		lcd_out(0x0021, Xpos);
		lcd_out(0x0022, Color);		// hbg\
	}
}
/***************************
*  `֐
***************************/
#define	abs(a)	(((a)>0) ? (a) : -(a))
void lcd_Line(short x0, short y0, short x1, short y1, unsigned short Color)
{
	short steep, t;
	short deltax, deltay, error;
	short x, y;
	short ystep;
	
	y0=ENDROW-y0 -1;						// YW]
	y1=ENDROW-y1 -1;
	/// ̑傫ق߂
	steep = (abs(y1 - y0) > abs(x1 - x0));
	/// A̓ւ
	if(steep){
		t = x0; x0 = y0; y0 = t;
		t = x1; x1 = y1; y1 = t;
	}
	if(x0 > x1) {
		t = x0; x0 = x1; x1 = t;
		t = y0; y0 = y1; y1 = t;
	}
	deltax = x1 - x0;						// XvZ	
	deltay = abs(y1 - y0);
	error = 0;
	y = y0;
	/// XŃXebv̐؂ւ
	if(y0 < y1) ystep = 1; else ystep = -1;
	/// _ŕ`
	for(x=x0; x<=x1; x++) {
		if(steep) lcd_Pixel(y,x,Color); else lcd_Pixel(x,y,Color);
		error += deltay;
		if((error << 1) >= deltax) {
			y += ystep;
			error -= deltax;
		}
	}
}
/*************************************
*  ~`֐
*  S_Ɣaw
*  (FussỹASYgp)
**************************************/
void lcd_Circle(int x0, int y0, int r, unsigned short color)
{
	int x = r;
	int y = 0;
	int F = -2 * r + 3;
	
	while(x >= y){
		lcd_Pixel(x0+x, y0+y, color);
		lcd_Pixel(x0-x, y0+y, color);		
		lcd_Pixel(x0+x, y0-y, color);
		lcd_Pixel(x0-x, y0-y, color);		
		lcd_Pixel(x0+y, y0+x, color);
		lcd_Pixel(x0-y, y0+x, color);		
		lcd_Pixel(x0+y, y0-x, color);
		lcd_Pixel(x0-y, y0-x, color);
		if(F >= 0){
			x--;
			F -= 4 * x;
		}
		y++;
		F += 4 * y + 2;
	}
}

/*****************************************
*  ANK\֐ 12x12hbg
*  320/12=26/s@240/14=17s
*  (0, 0) - (25, 16)͈̔
******************************************/
void lcd_Char(char colum, char line, unsigned char letter, unsigned short Color1, unsigned short Color2){
	unsigned char j, i, Mask;

	if((colum < XChar) && (line < YLine)){		// ͈̓`FbN
		// ANK\ó@3oCg2C6JԂ
		for(j=0; j<6; j++){
			// 8hbgA̕\
			Mask = 0x80;
			for(i=0; i<8; i++){
				// PCڑO8hbg\
				if((ANKFont[letter][j*3] & Mask) != 0)
					lcd_Pixel(colum*12+i+4, line*14+j*2+2, Color1);
				else
					lcd_Pixel(colum*12+i+4, line*14+j*2+2, Color2); 	//wiF
				// 2Cڌ㔼8hbg\
				if((ANKFont[letter][j*3+2] & Mask) != 0)
					lcd_Pixel(colum*12+i+8, line*14+j*2+3, Color1);
				else
					lcd_Pixel(colum*12+i+8, line*14+j*2+3, Color2); 	//wiF
				Mask = Mask >> 1;
			}
			// 4hbg\
			Mask = 0x80;
			// 1Cڌ㔼4hbg\
			for(i=0; i<4; i++){
				if((ANKFont[letter][j*3+1] & Mask) != 0)
					lcd_Pixel(colum*12+i+12, line*14+j*2+2, Color1);
				else
					lcd_Pixel(colum*12+i+12, line*14+j*2+2, Color2);	 //wiF
				Mask = Mask >> 1;
			}
			// 2CڑO4hbg\
			for(i=4; i<8; i++){
				if((ANKFont[letter][j*3+1] & Mask) != 0)
					lcd_Pixel(colum*12+i, line*14+j*2+3, Color1);
				else
					lcd_Pixel(colum*12+i, line*14+j*2+3, Color2); 	//wiF
				Mask = Mask >> 1;
			}							
		}
	}
}
/******************************
*   `֐
*   1620sŎw
******************************/
void lcd_Str(char colum, char line, char *s, unsigned short Color1, unsigned short Color2)
{
    	while (*s){
		lcd_Char(colum++, line, *s++, Color1, Color2);
		if(colum >= XChar){
			line++;
			colum = 0;
			if(line >= YLine)
				line = 0;
		}
	}
}
/**********************************
*  [vx֐@usecP
**********************************/
void delay_us(unsigned short usec){
	unsigned short i, Max;
	
	Max = 2*usec * Fosc/5;
	for(i=0; i<Max; i++)
	{	}
}
/**********************************
*  [vx֐@msecP
**********************************/		 
void delay_ms(unsigned short msec){
	unsigned short i;
	
	for(i=0; i<msec; i++)
		delay_us(1000);
}
